/*
 * Main class of the program
 *
 * Copyright (C) 2013 Guillaume Duc <guillaume.duc@telecom-paristech.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef ATTACK_WRAPPER_H
#define ATTACK_WRAPPER_H

#include <string>

#include "editions.h"

class Attack_Wrapper
{
  int cl_num_iterations;
  int cl_key_num;
  int cl_fifo_mode;
  int cl_truncate;

  std::string cl_output_filename;
  std::string cl_trace_dir;
  std::string cl_index_filename;
  std::string cl_attack_program_filename;

  std::string cl_edition;

  bool cl_comm_compatibility_v2;
  bool cl_provide_offset_v4_rsm;
  bool cl_provide_offsets_v4_2;
  bool cl_check_traces_availability;
  bool cl_use_float_format;

  Contest * contest;

public:
  Attack_Wrapper ();

  void parse_command_line (int argc, char **argv);

  void print_usage () const;
  void print_version () const;

  void run_contest ();
};

#endif /* ATTACK_WRAPPER_H */
